## python-scrapli 2023.7.30

=== Makefile ===
.DEFAULT_GOAL := help

help:
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-30s\033[0m %s\n", $$1, $$2}'

lint:  ## Run linters
	python -m isort .
	python -m black .
	python -m pylama .
	python -m pydocstyle .
	python -m mypy --strict scrapli/

darglint:  ## Run darglint (docstring/arg checker)
	find scrapli -type f \( -iname "*.py" \) | xargs darglint -x

test:  ## Run all tests
	python -m pytest \
	tests/

cov:  ## Run all tests with term and html coverage report
	python -m pytest \
	--cov=scrapli \
	--cov-report html \
	--cov-report term \
	tests/

test_unit:  ## Run all unit tests
	python -m pytest \
	tests/unit/

cov_unit:  ## Run all unit tests with term and html coverage report
	python -m pytest \
	--cov=scrapli \
	--cov-report html \
	--cov-report term \
	tests/unit/

test_integration:  ## Run integration tests
	python -m pytest \
	tests/integration/

cov_integration:  ## Run integration with term and html coverage report
	python -m pytest \
	--cov=scrapli \
	--cov-report html \
	--cov-report term \
	tests/integration/

test_functional:  ## Run functional tests
	python -m pytest \
	tests/functional/

cov_functional:  ## Run functional tests with term and html coverage report
	python -m pytest \
	--cov=scrapli \
	--cov-report html \
	--cov-report term \
	tests/functional/

.PHONY: docs
docs:  ## Regenerate docs
	python docs/generate.py

test_docs:  ## Run doc testing
	mkdocs build --clean --strict
	htmltest -c docs/htmltest.yml -s
	rm -rf tmp

deploy_docs:  ## Deploy docs to github
	mkdocs gh-deploy

deploy_clab: ## Deploy functional clab test topology
	cd .clab && sudo clab deploy -t topo-full.yaml

destroy_clab: ## Destroy functional clab test topology
	cd .clab && sudo clab destroy -t topo-full.yaml

prepare_dev_env: ## Prepare a running clab environment with base configs for testing
	python tests/prepare_devices.py cisco_iosxe,cisco_nxos,cisco_iosxr,arista_eos,juniper_junos

=== debian/changelog ===
python-scrapli (2023.7.30-2) unstable; urgency=medium

  * Rebuilt source-only.

 -- Thomas Goirand <zigo@debian.org>  Wed, 08 Nov 2023 14:18:32 +0100

python-scrapli (2023.7.30-1) unstable; urgency=medium

  * Initial release. (Closes: #1051838)

 -- Thomas Goirand <zigo@debian.org>  Wed, 13 Sep 2023 10:37:16 +0200

=== debian/control ===
Source: python-scrapli
Section: python
Priority: optional
Maintainer: Debian OpenStack <team+openstack@tracker.debian.org>
Uploaders:
 Thomas Goirand <zigo@debian.org>,
Build-Depends:
 debhelper (>= 10),
 dh-python,
 openstack-pkg-tools,
 pybuild-plugin-pyproject,
 python3-all,
 python3-poetry-core,
 python3-setuptools,
Build-Depends-Indep:
 python3-asyncssh,
 python3-mypy,
 python3-paramiko,
 python3-pyfakefs,
 python3-pytest,
 python3-pytest-asyncio,
 python3-scrapli-replay,
 python3-textfsm,
 python3-toml,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/openstack-team/python/python-scrapli
Vcs-Git: https://salsa.debian.org/openstack-team/python/python-scrapli.git
Homepage: https://github.com/carlmontanari/scrapli

Package: python3-scrapli
Architecture: all
Depends:
 python3-asyncssh,
 python3-paramiko,
 python3-textfsm,
 ${misc:Depends},
 ${python3:Depends},
Description: sync/async screen scraping client specifically for network devices
 scrapli (or scrap(e c)li) is a python library focused on connecting to
 devices, specifically network devices (routers/switches/firewalls/etc.) via
 Telnet or SSH.

=== debian/rules ===
#!/usr/bin/make -f

UPSTREAM_GIT := https://github.com/carlmontanari/scrapli
include /usr/share/openstack-pkg-tools/pkgos.make

export PYBUILD_NAME=scrapli
export PYBUILD_TEST_ARGS=-v tests/unit -k 'not test_factory_community_platform_defaults and not test_factory_community_platform_variant and not test_factory_no_scrapli_community_platform and not test_textfsm_get_template and not test_textfsm_parse and not test_ttp_parse and not test_response_parse_textfsm and not test_response_parse_ttp and not test_open_channel_no_session and not test_isalive_no_session and not test_write_exception and not test_socket_open_connection_refused'
# Making these work means adding python3-ntc-templates as build-depends,
# though this would be recursive build-depends, so we just skip these tests.
#FAILED tests/unit/test_factory.py::test_factory_community_platform_defaults[sync_factory]
#FAILED tests/unit/test_factory.py::test_factory_community_platform_defaults[async_factory]
#FAILED tests/unit/test_factory.py::test_factory_community_platform_variant[sync_factory]
#FAILED tests/unit/test_factory.py::test_factory_community_platform_variant[async_factory]
#FAILED tests/unit/test_factory.py::test_factory_community_platform_variant_driver_type[sync_factory]
#FAILED tests/unit/test_factory.py::test_factory_community_platform_variant_driver_type[async_factory]
#FAILED tests/unit/test_factory.py::test_factory_no_scrapli_community_platform
#FAILED tests/unit/test_helper.py::test_textfsm_get_template - ModuleNotFoundE...
#FAILED tests/unit/test_helper.py::test_textfsm_parse[to_dict_false] - Attribu...
#FAILED tests/unit/test_helper.py::test_textfsm_parse[to_dict_true] - Attribut...
#FAILED tests/unit/test_helper.py::test_textfsm_parse_string_path[to_dict_false]
#FAILED tests/unit/test_helper.py::test_textfsm_parse_string_path[to_dict_true]
#FAILED tests/unit/test_helper.py::test_textfsm_parse_url_path[to_dict_false]
#FAILED tests/unit/test_helper.py::test_textfsm_parse_url_path[to_dict_true]
#FAILED tests/unit/test_helper.py::test_textfsm_parse_failed_to_parse - Attrib...
#FAILED tests/unit/test_helper.py::test_ttp_parse - AssertionError: assert [] ...
#FAILED tests/unit/test_helper.py::test_ttp_parse_failed_to_parse - assert [] ...
#FAILED tests/unit/test_response.py::test_response_parse_textfsm[to_dict_false]
#FAILED tests/unit/test_response.py::test_response_parse_textfsm[to_dict_true]
#FAILED tests/unit/test_response.py::test_response_parse_textfsm_string_path
#FAILED tests/unit/test_response.py::test_response_parse_ttp - IndexError: lis...
#FAILED tests/unit/test_response.py::test_response_parse_ttp_fail - assert [] ...
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_open_channel_no_session
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_isalive_no_session
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_write_exception

# These are failing because of missing ssh2 module. This module is for ssh to AWS instances.
# I personally don't care about AWS (but care about OpenStack). Anyone willing to fix the
# situation must package python3-ssh2, and add (build-)depends in this package.
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_open_channel_no_session
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_isalive_no_session
#ERROR tests/unit/transport/plugins/ssh2/test_ssh2_transport.py::test_write_exception

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_clean:
	rm -rf build *.egg-info .pybuild
	find . -iname '*.pyc' -delete
	for i in $$(find . -type d -iname __pycache__) ; do rm -rf $$i ; done

=== debian/watch ===
version=4
opts="mode=git,uversionmangle=s/\.0rc/~rc/;s/\.0b1/~b1/;s/\.0b2/~b2/;s/\.0b3/~b3/" \
https://github.com/carlmontanari/scrapli.git refs/tags/(\d[brc\d\.]+)
